# reads in a list of words, linear search for user-supplied word
# words in list can be in any order
# also print number of words checked for each search
# and at the end, the average number of words checked per search
# Matt Bishop, ECS 10, Spring 2014

# this is global just to emphasize how that works
wordlist = []

# this counts how many words you check before finding the word
# (or giving up)
wordcount = 0

# search a list of words for a word (linear search)
# parameters: word, the word to find in the list
# returns: index (+1) of word in list
#          -1 if not in list
# globals: wordlist, list to search
def search(word):
        # declaration
        global wordlist, wordcount
        # go through the list a word at a time
        for i in range(len(wordlist)):
                # one more word looked at
                wordcount += 1
                # see if there is a match
                if wordlist[i] == word:
                        # yep! return position (success)
                        return i + 1
        # return what you found
        return -1

# load words from a file to a list; assumes one word per line
# parameters: none
# returns: True if words loaded successfully
#          False if problem opening file
# globals: wordlist, list to append words to
def loadfile():
        # declaration
        global wordlist
        # open the file, trapping errors
        try:
                infile = open("listu.txt", "r")
        except IOError as errmsg:
                # say why it failed, return error code
                print("Could not open 'list.txt':", errmsg)
                return False
        # go through the file line by line
        for i in infile:
                # strip any leading and trailing white space (inc. newline)
                i = i.strip()
                # tack the word onto the list
                wordlist.append(i)
        # all done! close file and return success code
        infile.close()
        return True


# this puts it all together
def main():
        # declaration
        global wordlist, wordcount
        # load the word list; on error, quit
        if not loadfile():
                return
        # this counts total words checked across all searches
        totalwords = 0
        # count number of searches to compute average number
        # of words examined per search
        nsearch = 0
        # loop 
        while True:
                # read in word; quit on EOF
                try:
                        find = input("What word should I look for EOF to quit)? ")
                except EOFError:
                        break
                # count number of words searched for
                nsearch += 1
                # initialize number of words checked
                wordcount = 0
                # find the word if it's there
                found = search(find)
                # announce result
                if found == -1:
                        print("'%s' is not in the list" % find)
                else:
                        print("'%s' is word number %d" % (find, found))
                # print number of words checked
                if wordcount == 1:
                        print("Checked 1 word")
                else:
                        print("Checked", wordcount, "words")
                # increment total words checked
                totalwords += wordcount
        # give the average number of words checked per search
        print("On average, checked", float(totalwords)/nsearch, "words")


main()
